package cloud.io;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.Reader;
import java.lang.*;
import java.net.URL;
import java.util.ArrayList;
import java.util.StringTokenizer;
import cloud.atom.AtomInfo;
import cloud.atom.ElectricState;

//--------------------------------------------------------------------//
/**
 * qǂݍ݃NX
 */
public class AtomReader{

/**
 * qǂݍ݃IuWFNg\z
 */
  public AtomReader(){
  }

//--------------------------------------------------------------------//
/**
 * qf[^ǂݍ
 * @param is ̓Xg[
 * @return qf[^i[z
 * @throws IOException 炩̗RŃt@Cǂ߂ȂƂ
 */
  public static AtomInfo[] read(InputStream is) throws IOException{
    return readData(new BufferedReader(new InputStreamReader(is)));
  }

//--------------------------------------------------------------------//
/**
 * qf[^ǂݍ
 * @param reader ̓[_[
 * @return qf[^i[z
 * @throws IOException 炩̗RŃt@Cǂ߂ȂƂ
 */
  public static AtomInfo[] read(Reader reader) throws IOException{
    return readData(new BufferedReader(reader));
  }

//--------------------------------------------------------------------//
/**
 * qf[^ǂݍ
 * @param url f[^ URL
 * @return qf[^i[z
 * @throws IOException 炩̗RŃt@Cǂ߂ȂƂ
 */
  public static AtomInfo[] read(URL url) throws IOException{
    InputStream is=url.openStream();
    AtomInfo info[]=readData
      (new BufferedReader(new InputStreamReader(is)));
    if(is!=null) is.close();
    return info;
  }

//--------------------------------------------------------------------//
/**
 * qf[^ǂݍ
 * @param br ̓[_[
 * @return qf[^i[z
 * @throws IOException 炩̗RŃt@Cǂ߂ȂƂ
 */
  public static AtomInfo[] readData(BufferedReader br)
    throws IOException{

    ArrayList list=new ArrayList();
    while(true){
      String line=br.readLine();
      if(line==null) break;
      StringTokenizer st=new StringTokenizer(line);
      AtomInfo info=toAtomInfo(st);
      if(info!=null){
      	list.add(info);
      }
    }
    br.close();

    list.trimToSize();
    int size=list.size();
    AtomInfo info[]=new AtomInfo[size];
    for(int i=0;i<size;i++){
      info[i]=(AtomInfo)list.get(i);
    }
    return info;
  }

//--------------------------------------------------------------------//
/**
 * qf[^ǂݍ
 * @param st f[^ǂݍ <code>StringTokenizer</code>
 * @return qf[^i[z<br>
 *         f[^ǂݍ߂Ȃꍇ null Ԃ
 */
  protected static AtomInfo toAtomInfo(StringTokenizer st){
    try{
      int length=st.countTokens()-2;
      int z=Integer.parseInt(st.nextToken());
      String name=st.nextToken();
      ElectricState states[]=new ElectricState[length];
      for(int i=0;i<length;i++){
      	states[i]=toElectricState(st.nextToken());
      }
      return new AtomInfo(z,name,states);
    }
    catch(NumberFormatException ex){
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * dqԃf[^Ԃ
 * @param s f[^ǂݍޕ
 * @return dqԃf[^
 * @throws NumberFormatException ǂݍ݃G[Ƃ
 */
  public static ElectricState toElectricState(String s)
    throws NumberFormatException{

    int n=Integer.parseInt(s.substring(0,1));
    String ls=s.substring(1,2).toLowerCase();
    int count=Integer.parseInt(s.substring(2,s.length()));
    if(ls.equals("s")){
      return new ElectricState(n,0,count);
    }
    else if(ls.equals("p")){
      return new ElectricState(n,1,count);
    }
    else if(ls.equals("d")){
      return new ElectricState(n,2,count);
    }
    else if(ls.equals("f")){
      return new ElectricState(n,3,count);
    }
    else if(ls.equals("g")){
      return new ElectricState(n,4,count);
    }
    else if(ls.equals("h")){
      return new ElectricState(n,5,count);
    }
    else{
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * 𕪊
 * @param s 镶
 * @return i[z
  public static String[] split(String s){
    String ss[]=s.split("\\s+");
    if((ss.length==0) || !ss[0].equals("")){
      return ss;
    }
    else{
      String ss2[]=new String[ss.length-1];
      System.arraycopy(ss,1,ss2,0,ss.length-1);
      return ss2;
    }
  }
 */
}
