package math;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * WhNX
 */
public class AssociatedLegendre{

//--------------------------------------------------------------------//
/**
 * Wh̒lԂ
 * @param x ϐl
 * @param n 
 * @param m 
 * @return ֐l
 */
  public static double get(double x,int n,int m){
    int imax=(n-m)/2;
    double x2=x*x;
    double coef=Math.pow(1.0-x2,(double)(m/2))/Math.pow(2.0,(double)n);
    double p=coef/(factorial(imax)*factorial(n-m-2*imax));
    if(n-m!=2*imax) p*=x;
    if(imax%2==1) p=-p;
    for(int i=0;i<n-imax;i++) p*=(double)(2*(n-imax)-i);
    double s=p;
    for(int i=imax;i>0;i--){
      int i1=2*i*(2*(n-i)+1);
      int i2=n-m-2*i;
      i2=(i2+2)*(i2+1);
      p*=-x2*(double)i1/(double)i2;
      s+=p;
    }
    return s;
  }

//--------------------------------------------------------------------//
/**
 * K̒lԂ
 * @param n ϐl
 * @return K̒l
 */
  protected static double factorial(int n){
    double f=1.0;
    for(int i=1;i<n;i++) f*=(double)(i+1);
    return f;
  }
}
