package math;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * 2 ֐NX
 */
public class ConicFunction implements DifferentiableFunction,Cloneable{

/** 2 W */
  public double a2;

/** 1 W */
  public double a1;

/** 萔W */
  public double a0;

/**
 * Ww肵ăIuWFNg\z
 * @param a2 2 W
 * @param a1 1 W
 * @param a0 萔W
 */
  public ConicFunction(double a2,double a1,double a0){
    this.a2=a2;
    this.a1=a1;
    this.a0=a0;
  }

//--------------------------------------------------------------------//
/**
 * ֐lԂ
 * @param x ϐl
 * @return ֐l
 */
  public double getValue(double x){
    return (a2*x+a1)*x+a0;
  }

//--------------------------------------------------------------------//
/**
 * ֐Ԃ
 * @return ֐
 */
  public Function getDerivative(){
    return new LinearFunction(2.0*a2,a1);
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      return super.clone();
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    long l2=Double.doubleToLongBits(a2);
    long l1=Double.doubleToLongBits(a1);
    long l0=Double.doubleToLongBits(a0);
    int bit2=(int)(l2^(l2>>>32));
    int bit1=(int)(l1^(l1>>>32));
    int bit0=(int)(l0^(l0>>>32));
    return (bit2^bit1^bit0);
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>CubicFunction</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof ConicFunction){
      ConicFunction cf=(ConicFunction)obj;
      return ((a2==cf.a2) && (a1==cf.a1) && (a0==cf.a0));
    }
    return false;
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "ConicFunction\t"+a2+"\t"+a1+"\t"+a0;
  }
}
