package math;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * 1 ֐NX
 */
public class LinearFunction implements DifferentiableFunction,Cloneable{

/** 1 W */
  public double a1;

/** 萔W */
  public double a0;

/**
 * Ww肵ăIuWFNg\z
 * @param a1 1 W
 * @param a0 萔W
 */
  public LinearFunction(double a1,double a0){
    this.a1=a1;
    this.a0=a0;
  }

//--------------------------------------------------------------------//
/**
 * ֐lԂ
 * @param x ϐl
 * @return ֐l
 */
  public double getValue(double x){
    return a1*x+a0;
  }

//--------------------------------------------------------------------//
/**
 * ֐Ԃ
 * @return ֐
 */
  public Function getDerivative(){
    return new ConstantFunction(a1);
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      return super.clone();
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    long l1=Double.doubleToLongBits(a1);
    long l0=Double.doubleToLongBits(a0);
    int bit1=(int)(l1^(l1>>>32));
    int bit0=(int)(l0^(l0>>>32));
    return (bit1^bit0);
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>LinearFunction</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof LinearFunction){
      LinearFunction lf=(LinearFunction)obj;
      return ((a1==lf.a1) && (a0==lf.a0));
    }
    return false;
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "LinearFunction\t"+a1+"\t"+a0;
  }
}
