package cloud;
import java.awt.Choice;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.lang.*;
import java.util.HashMap;
import java.util.Map;
import cloud.atom.AtomInfo;

//--------------------------------------------------------------------//
/**
 * qI`CX
 */
public class AtomChoice extends Choice implements ItemListener{

/** dq_\LoX */
  protected CloudViewCanvas canvas;

/** qi[}bv*/
  protected Map map;

/**
 * qI`CX\z
 * @param canvas dq_\LoX
 * @param info qi[z
 */
  public AtomChoice(CloudViewCanvas canvas,AtomInfo info[]){
    this.canvas=canvas;
    map=new HashMap();
    for(int i=0;i<info.length;i++){
      add(info[i].getName());
      map.put(info[i].getName(),info[i]);
    }
    select(0);
    addItemListener(this);
  }

//--------------------------------------------------------------------//
/**
 * qI
 * @param e ANVƂCxg
 */
  public void itemStateChanged(ItemEvent e){
    Object value=map.get(e.getItem());
    if(value instanceof AtomInfo){
      canvas.setAtom((AtomInfo)value);
      canvas.repaint();
    }
  }
}
