package math;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * 3 ֐NX
 */
public class CubicFunction implements DifferentiableFunction,Cloneable{

/** 3 W */
  public double a3;

/** 2 W */
  public double a2;

/** 1 W */
  public double a1;

/** 萔W */
  public double a0;

/**
 * Ww肵ăIuWFNg\z
 * @param a3 3 W
 * @param a2 2 W
 * @param a1 1 W
 * @param a0 萔W
 */
  public CubicFunction(double a3,double a2,double a1,double a0){
    this.a3=a3;
    this.a2=a2;
    this.a1=a1;
    this.a0=a0;
  }

//--------------------------------------------------------------------//
/**
 * ֐lԂ
 * @param x ϐl
 * @return ֐l
 */
  public double getValue(double x){
    return ((a3*x+a2)*x+a1)*x+a0;
  }

//--------------------------------------------------------------------//
/**
 * ֐Ԃ
 * @return ֐
 */
  public Function getDerivative(){
    return new ConicFunction(3.0*a3,2.0*a2,a1);
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      return super.clone();
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    long l3=Double.doubleToLongBits(a3);
    long l2=Double.doubleToLongBits(a2);
    long l1=Double.doubleToLongBits(a1);
    long l0=Double.doubleToLongBits(a0);
    int bit3=(int)(l3^(l3>>>32));
    int bit2=(int)(l2^(l2>>>32));
    int bit1=(int)(l1^(l1>>>32));
    int bit0=(int)(l0^(l0>>>32));
    return (bit3^bit2^bit1^bit0);
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>CubicFunction</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof CubicFunction){
      CubicFunction cf=(CubicFunction)obj;
      return ((a3==cf.a3) && (a2==cf.a2) && (a1==cf.a1) && (a0==cf.a0));
    }
    return false;
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "CubicFunction\t"+a3+"\t"+a2+"\t"+a1+"\t"+a0;
  }
}
